--- emacs24-24.3+1.orig/lisp/progmodes/cc-menus.el
+++ emacs24-24.3+1/lisp/progmodes/cc-menus.el
@@ -1,31 +1,33 @@
 ;;; cc-menus.el --- imenu support for CC Mode
 
-;; Copyright (C) 1985, 1987, 1992-2013 Free Software Foundation, Inc.
+;; Copyright (C) 1985, 1987, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
+;;   1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009,
+;;   2010, 2011   Free Software Foundation, Inc.
 
 ;; Authors:    1998- Martin Stjernholm
-;;             1992-1999 Barry A. Warsaw
-;;             1987 Dave Detlefs
-;;             1987 Stewart Clamen
-;;             1985 Richard M. Stallman
+;;	       1992-1999 Barry A. Warsaw
+;;	       1987 Dave Detlefs and Stewart Clamen
+;;	       1985 Richard M. Stallman
 ;; Maintainer: bug-cc-mode@gnu.org
 ;; Created:    22-Apr-1997 (split from cc-mode.el)
-;; Keywords:   c languages
-;; Package:    cc-mode
+;; Version:    See cc-mode.el
+;; Keywords:   c languages oop
 
 ;; This file is part of GNU Emacs.
 
-;; GNU Emacs is free software: you can redistribute it and/or modify
+;; GNU Emacs is free software; you can redistribute it and/or modify
 ;; it under the terms of the GNU General Public License as published by
-;; the Free Software Foundation, either version 3 of the License, or
-;; (at your option) any later version.
+;; the Free Software Foundation; either version 3, or (at your option)
+;; any later version.
 
 ;; GNU Emacs is distributed in the hope that it will be useful,
 ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
-;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 ;; GNU General Public License for more details.
 
 ;; You should have received a copy of the GNU General Public License
-;; along with GNU Emacs.  If not, see <http://www.gnu.org/licenses/>.
+;; along with this program; see the file COPYING.  If not, see
+;; <http://www.gnu.org/licenses/>.
 
 ;;; Commentary:
 
@@ -45,6 +47,7 @@
 (cc-bytecomp-defvar imenu-case-fold-search)
 (cc-bytecomp-defvar imenu-generic-expression)
 (cc-bytecomp-defvar imenu-create-index-function)
+(cc-bytecomp-defun imenu-progress-message)
 
 
 ;; imenu integration
@@ -80,27 +83,27 @@ A sample value might look like: `\\(_P\\
 (defvar cc-imenu-c++-generic-expression
   `(
     ;; Try to match ::operator definitions first. Otherwise `X::operator new ()'
-    ;; will be incorrectly recognized as function `new ()' because the regexps
+    ;; will be incorrectly recognised as function `new ()' because the regexps
     ;; work by backtracking from the end of the definition.
     (nil
      ,(concat
        "^\\<.*"
-       "[^" c-alnum "_:<>~]"                  ; match any non-identifier char
-                                              ; (note: this can be `\n')
+       "[^" c-alnum "_:<>~]"		      ; match any non-identifier char
+					      ; (note: this can be `\n')
        "\\("
 	  "\\([" c-alnum "_:<>~]*::\\)?"      ; match an operator
-          "operator\\>[ \t]*"
-          "\\(()\\|[^(]*\\)"                  ; special case for `()' operator
+	  "operator\\>[ \t]*"
+	  "\\(()\\|[^(]*\\)"		      ; special case for `()' operator
        "\\)"
 
-       "[ \t]*([^)]*)[ \t]*[^ \t;]"           ; followed by ws, arg list,
-                                              ; require something other than
-                                              ; a `;' after the (...) to
-                                              ; avoid prototypes.  Can't
-                                              ; catch cases with () inside
-                                              ; the parentheses surrounding
-                                              ; the parameters.  e.g.:
-                                              ; `int foo(int a=bar()) {...}'
+       "[ \t]*([^)]*)[ \t]*[^ \t;]"	      ; followed by ws, arg list,
+					      ; require something other than
+					      ; a `;' after the (...) to
+					      ; avoid prototypes.  Can't
+					      ; catch cases with () inside
+					      ; the parentheses surrounding
+					      ; the parameters.	 e.g.:
+					      ; `int foo(int a=bar()) {...}'
        ) 1)
     ;; Special case to match a line like `main() {}'
     ;; e.g. no return type, not even on the previous line.
@@ -109,17 +112,15 @@ A sample value might look like: `\\(_P\\
        "^"
        "\\([" c-alpha "_][" c-alnum "_:<>~]*\\)" ; match function name
        "[ \t]*("			      ; see above, BUT
-       "[ \t]*\\([^ \t(*][^)]*\\)?)"          ; the arg list must not start
-       "[ \t]*[^ \t;(]"                       ; with an asterisk or parentheses
+       "[ \t]*\\([^ \t(*][^)]*\\)?)"	      ; the arg list must not start
+       "[ \t]*[^ \t;(]"			      ; with an asterisk or parentheses
        ) 1)
     ;; General function name regexp
     (nil
      ,(concat
-       "^\\<"                                 ; line MUST start with word char
-       ;; \n added to prevent overflow in regexp matcher.
-       ;; http://lists.gnu.org/archive/html/emacs-pretest-bug/2007-02/msg00021.html
-       "[^()\n]*"                             ; no parentheses before
-       "[^" c-alnum "_:<>~]"                  ; match any non-identifier char
+       "^\\<"				      ; line MUST start with word char
+       "[^()]*"				      ; no parentheses before
+       "[^" c-alnum "_:<>~]"		      ; match any non-identifier char
        "\\([" c-alpha "_][" c-alnum "_:<>~]*\\)" ; match function name
        "\\([ \t\n]\\|\\\\\n\\)*("	      ; see above, BUT the arg list
        "\\([ \t\n]\\|\\\\\n\\)*"	      ; must not start
@@ -133,77 +134,160 @@ A sample value might look like: `\\(_P\\
     ;; This case is only included if cc-imenu-c-prototype-macro-regexp is set.
     ;; Only supported in c-code, so no `:<>~' chars in function name!
     ,@(if cc-imenu-c-prototype-macro-regexp
-            `((nil
-                 ,(concat
-                   "^\\<.*"                   ; line MUST start with word char
-		   "[^" c-alnum "_]"          ; match any non-identifier char
+	    `((nil
+		 ,(concat
+		   "^\\<.*"		      ; line MUST start with word char
+		   "[^" c-alnum "_]"	      ; match any non-identifier char
 		   "\\([" c-alpha "_][" c-alnum "_]*\\)" ; match function name
-                   "[ \t]*"                   ; whitespace before macro name
-                   cc-imenu-c-prototype-macro-regexp
-                   "[ \t]*("                  ; ws followed by first paren.
-                   "[ \t]*([^)]*)[ \t]*)[ \t]*[^ \t;]" ; see above
-                   ) 1)))
+		   "[ \t]*"		      ; whitespace before macro name
+		   cc-imenu-c-prototype-macro-regexp
+		   "[ \t]*("		      ; ws followed by first paren.
+		   "[ \t]*([^)]*)[ \t]*)[ \t]*[^ \t;]" ; see above
+		   ) 1)))
     ;; Class definitions
     ("Class"
      ,(concat
-         "^"                                  ; beginning of line is required
-         "\\(template[ \t]*<[^>]+>[ \t]*\\)?" ; there may be a `template <...>'
-         "\\(class\\|struct\\)[ \t]+"
-         "\\("                                ; the string we want to get
-	 "[" c-alnum "_]+"                    ; class name
-         "\\(<[^>]+>\\)?"                     ; possibly explicitly specialized
-         "\\)"
-         "\\([ \t\n]\\|\\\\\n\\)*[:{]"
-         ) 3))
+	 "^"				      ; beginning of line is required
+	 "\\(template[ \t]*<[^>]+>[ \t]*\\)?" ; there may be a `template <...>'
+	 "\\(class\\|struct\\)[ \t]+"
+	 "\\("				      ; the string we want to get
+	 "[" c-alnum "_]+"		      ; class name
+	 "\\(<[^>]+>\\)?"		      ; possibly explicitly specialized
+	 "\\)"
+	 "\\([ \t\n]\\|\\\\\n\\)*[:{]"
+	 ) 3))
   "Imenu generic expression for C++ mode.  See `imenu-generic-expression'.")
 
 (defvar cc-imenu-c-generic-expression
   cc-imenu-c++-generic-expression
-  "Imenu generic expression for C mode.  See `imenu-generic-expression'.")
+  "Imenu generic expression for C mode.	 See `imenu-generic-expression'.")
 
-(defvar cc-imenu-java-generic-expression
+
+;; Auxiliary regexps for Java try to match their trailing whitespace where
+;; appropriate, but _not_ starting whitespace.
+
+(defconst cc-imenu-java-ellipsis-regexp
+  (concat
+   "\\.\\{3\\}"
+   "[ \t\n\r]*"))
+
+(defun cc-imenu-java-build-type-args-regex (depth)
+  "Builds regexp for type arguments list with DEPTH allowed
+nested angle brackets constructs."
+  (if (> depth 0)
+      (concat "<"
+		"[][.," c-alnum "_? \t\n\r]+"
+		(if (> depth 1)
+		    "\\(")
+		(cc-imenu-java-build-type-args-regex (1- depth))
+		(if (> depth 1)
+		  (concat "[][.," c-alnum "_? \t\n\r]*"
+			  "\\)*"))
+	      ">")))
+
+(defconst cc-imenu-java-type-spec-regexp
+  (concat
+   ;; zero or more identifiers followed by a dot
+   "\\("
+     "[" c-alpha "_][" c-alnum "_]*\\."
+   "\\)*"
+   ;; a single mandatory identifier without a dot
+   "[" c-alpha "_][" c-alnum "_]*"
+   ;; then choice:
+   "\\("
+   ;; (option 1) type arguments list which _may_ be followed with brackets
+   ;; and/or spaces, then optional variable arity
+     "[ \t\n\r]*"
+     (cc-imenu-java-build-type-args-regex 3)
+     "[][ \t\n\r]*"
+     "\\(" cc-imenu-java-ellipsis-regexp "\\)?"
+   "\\|"
+   ;; (option 2) just brackets and/or spaces (there should be at least one),
+   ;; then optional variable arity
+     "[][ \t\n\r]+"
+     "\\(" cc-imenu-java-ellipsis-regexp "\\)?"
+   "\\|"
+   ;; (option 3) just variable arity
+     cc-imenu-java-ellipsis-regexp
+   "\\)"))
+
+(defconst cc-imenu-java-comment-regexp
+  (concat
+   "/"
+   "\\("
+   ;; a traditional comment
+     "\\*"
+     "\\("
+       "[^*]"
+     "\\|"
+       "\\*+[^/*]"
+     "\\)*"
+     "\\*+/"
+   "\\|"
+   ;; an end-of-line comment
+     "/[^\n\r]*[\n\r]"
+   "\\)"
+  "[ \t\n\r]*"
+   ))
+
+;; Comments are allowed before the argument, after any of the
+;; modifiers and after the identifier.
+(defconst cc-imenu-java-method-arg-regexp
+  (concat
+   "\\(" cc-imenu-java-comment-regexp "\\)*"
+   ;; optional modifiers
+   "\\("
+     ;; a modifier is either an annotation or "final"
+     "\\("
+       "@[" c-alpha "_]"
+       "[" c-alnum "._]*"
+       ;; TODO support element-value pairs!
+     "\\|"
+       "final"
+     "\\)"
+     ;; a modifier ends with comments and/or ws
+     "\\("
+       "\\(" cc-imenu-java-comment-regexp "\\)+"
+     "\\|"
+       "[ \t\n\r]+"
+       "\\(" cc-imenu-java-comment-regexp "\\)*"
+     "\\)"
+   "\\)*"
+   ;; type spec
+   cc-imenu-java-type-spec-regexp
+   ;; identifier
+   "[" c-alpha "_]"
+   "[" c-alnum "_]*"
+   ;; optional comments and/or ws
+   "[ \t\n\r]*"
+   "\\(" cc-imenu-java-comment-regexp "\\)*"
+   ))
+
+(defconst cc-imenu-java-generic-expression
   `((nil
      ,(concat
-       "[" c-alpha "_][\]\[." c-alnum "_<> ]+[ \t\n\r]+" ; type spec
-       "\\([" c-alpha "_][" c-alnum "_]*\\)" ; method name
+       cc-imenu-java-type-spec-regexp
+       "\\("				      ; method name which gets captured
+					      ; into index
+         "[" c-alpha "_]"
+         "[" c-alnum "_]*"
+       "\\)"
        "[ \t\n\r]*"
-       ;; An argument list htat is either empty or contains any number
-       ;; of arguments.  An argument is any number of annotations
-       ;; followed by a type spec followed by a word.  A word is an
-       ;; identifier.  A type spec is an identifier, possibly followed
-       ;; by < typespec > possibly followed by [].
-       (concat "("
-               "\\("
-               "[ \t\n\r]*"
-               "\\("
-               "@"
-               "[" c-alpha "_]"
-               "[" c-alnum "._]""*"
-               "[ \t\n\r]+"
-               "\\)*"
-               "\\("
-               "[" c-alpha "_]"
-               "[\]\[" c-alnum "_.]*"
-               "\\("
-
-               "<"
-               "[ \t\n\r]*"
-               "[\]\[.," c-alnum "_<> \t\n\r]*"
-               ">"
-               "\\)?"
-               "\\(\\[\\]\\)?"
-               "[ \t\n\r]+"
-               "\\)"
-               "[" c-alpha "_]"
-               "[" c-alnum "_]*"
-               "[ \t\n\r,]*"
-               "\\)*"
-               ")"
-               "[.," c-alnum " \t\n\r]*"
-               "{"
-	       )) 1))
+       ;; An argument list that contains zero or more arguments.
+       (concat
+	"("
+	"[ \t\n\r]*"
+	"\\("
+	  "\\(" cc-imenu-java-method-arg-regexp ",[ \t\n\r]*\\)*"
+	  cc-imenu-java-method-arg-regexp
+	"\\)?"
+	")"
+	"[.,_" c-alnum " \t\n\r]*"	      ; throws etc.
+	"{"
+	)) 7))
   "Imenu generic expression for Java mode.  See `imenu-generic-expression'.")
 
+
 ;; Internal variables
 (defvar cc-imenu-objc-generic-expression-noreturn-index nil)
 (defvar cc-imenu-objc-generic-expression-general-func-index nil)
@@ -242,7 +326,7 @@ A sample value might look like: `\\(_P\\
    ;; Pick a token by (match-string 8 or 9)
    ;;
    "\\|\\("
-   "^[-+][:" c-alnum "()*_<>\n\t ]*[;{]"        ; Methods
+   "^[-+][:" c-alnum "()*_<>\n\t ]*[;{]"	; Methods
    "\\|"
    "^@interface[\t ]+[" c-alnum "_]+[\t ]*:"
    "\\|"
@@ -278,7 +362,7 @@ Example:
 	    p (1+ p))
       (cond
        ;; Is CHAR part of a objc token?
-       ((and (not inargvar)     ; Ignore if CHAR is part of an argument variable.
+       ((and (not inargvar)	; Ignore if CHAR is part of an argument variable.
 	     (eq 0 betweenparen) ; Ignore if CHAR is in parentheses.
 	     (or (and (<= ?a char) (<= char ?z))
 		 (and (<= ?A char) (<= char ?Z))
@@ -304,7 +388,7 @@ Example:
 	(setq betweenparen (1- betweenparen)))))
     return))
 
-(defun cc-imenu-objc-remove-white-space  (str)
+(defun cc-imenu-objc-remove-white-space	 (str)
   "Remove all spaces and tabs from STR."
   (let ((return "")
 	(p 0)
@@ -319,13 +403,13 @@ Example:
     return))
 
 (defun cc-imenu-objc-function ()
-  "Imenu support for Objective C mode."
+  "imenu supports for objc-mode."
   (let (methodlist
 	clist
 	;;
 	;; OBJC, Cnoreturn, Cgeneralfunc, Cproto are constants.
 	;;
-	;;                  *Warning for developers*
+	;;		    *Warning for developers*
 	;; These constants depend on `cc-imenu-c++-generic-expression'.
 	;;
 	(OBJC cc-imenu-objc-generic-expression-objc-base-index)
@@ -342,11 +426,11 @@ Example:
 	str
 	str2
 	(intflen (length "@interface"))
-	(implen  (length "@implementation"))
-	(prtlen  (length "@protocol"))
+	(implen	 (length "@implementation"))
+	(prtlen	 (length "@protocol"))
 	(func
 	 ;;
-	 ;; Does this emacs have buffer-substring-no-properties?
+	 ;; Does this emacs has buffer-substring-no-properties?
 	 ;;
 	 (if (fboundp 'buffer-substring-no-properties)
 	     'buffer-substring-no-properties
@@ -399,10 +483,14 @@ Example:
 		str2 "@protocol")))
 	(setq str (cc-imenu-objc-remove-white-space str))
 	(setq methodlist (cons (cons str2
-				     (match-beginning langnum))
+			      (match-beginning langnum))
 			       methodlist))
-	(setq toplist (cons (cons str methodlist) toplist)
+	(setq toplist (cons nil (cons (cons str
+					  methodlist) toplist))
 	      methodlist nil))))
+    ;;
+    (if (eq (car toplist) nil)
+	(setq toplist (cdr toplist)))
 
     ;; In this buffer, there is only one or zero @{interface|implementation|protocol}.
     (if (< classcount 2)
@@ -438,4 +526,5 @@ Example:
 
 (cc-provide 'cc-menus)
 
+;;; arch-tag: f6b60933-91f0-4145-ab44-70ca6d1b919b
 ;;; cc-menus.el ends here
